#include <stdlib.h>
#include <assert.h>

#include "driver.h"

int drv_open(const struct driver *drv)
{
    assert(drv != NULL);

    return drv->fp->open(drv);
}

int drv_close(const struct driver *drv)
{
    assert(drv != NULL);

    return drv->fp->close(drv);
}

int drv_read(const struct driver *drv, char *buffer, unsigned int length)
{
    assert(drv != NULL);

    return drv->fp->read(drv, buffer, length);
}

int drv_write(const struct driver *drv, const char *buffer, unsigned int length)
{
    assert(drv != NULL);

    return drv->fp->write(drv, buffer, length);
}
